/**
 * 
 */
package eu.etaxonomy.taxeditor.test;

import java.util.List;

import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.Widget;
import org.eclipse.swtbot.eclipse.finder.SWTWorkbenchBot;
import org.eclipse.swtbot.eclipse.finder.matchers.WidgetMatcherFactory;
import org.eclipse.swtbot.eclipse.finder.waits.Conditions;
import org.eclipse.swtbot.eclipse.finder.widgets.SWTBotView;
import org.eclipse.swtbot.swt.finder.exceptions.WidgetNotFoundException;
import org.eclipse.swtbot.swt.finder.finders.ChildrenControlFinder;
import org.eclipse.swtbot.swt.finder.junit.SWTBotJunit4ClassRunner;
import org.eclipse.swtbot.swt.finder.utils.SWTBotPreferences;
import org.eclipse.swtbot.swt.finder.widgets.SWTBotTree;
import org.junit.Before;
import org.junit.runner.RunWith;

/**
 * @author n.hoffmann
 *
 */
@RunWith(SWTBotJunit4ClassRunner.class)
public abstract class AbstractEditorTest {
	
	protected SWTWorkbenchBot bot;
	
	@Before
	public void setup() {
		bot = new SWTWorkbenchBot();
		SWTBotPreferences.TIMEOUT = 300000;
		
		String activeText = bot.activeShell().getText();
		if(activeText.equals("Connecting to datasource: cdm")){
			bot.waitUntil(Conditions.shellIsActive("Login"));
			bot.button("Cancel").click();
		}
	}

	
	/**
	 * @return
	 * @throws WidgetNotFoundException
	 */
	public SWTBotTree tree(Widget widget) throws WidgetNotFoundException {
		List<Tree> controls = new ChildrenControlFinder(widget).findControls(WidgetMatcherFactory.widgetOfType(Tree.class));
		if (controls.isEmpty())
			throw new WidgetNotFoundException("Could not find any tree");
		SWTBotTree tree = new SWTBotTree((Tree) controls.get(0));
		return tree;
	}

	/**
	 * @return
	 * @throws WidgetNotFoundException
	 */
	public SWTBotView view(String title) throws WidgetNotFoundException {
		return bot.viewByTitle(title);
	}
	
	public void cancel() {
		clickButton("Cancel");
	}
	
	public void ok() {
		clickButton("OK");
	}
	
	public void clickButton(String label) {
		bot.button(label).click();
	}
}
