package eu.etaxonomy.taxeditor.test;

import org.eclipse.swtbot.eclipse.finder.waits.Conditions;
import org.junit.Test;

/**
 * Open all new menus
 * 
 * @author n.hoffmann
 *
 */
public class NewMenuTest extends AbstractEditorTest {

	@Test
	public void canOpenNewWizardForTaxon(){
		openNewWizardFor("Taxon");
		cancel();
	}
	

	@Test
	public void canOpenNewWizardForReference(){
		openNewWizardFor("Reference");
		cancel();
	}
	
	
	@Test
	public void canOpenNewWizardForName(){
		openNewWizardFor("Name");
		cancel();
	}
	
	
	@Test
	public void canOpenNewWizardForTeam(){
		openNewWizardFor("Team");
		cancel();
	}
	
	
	@Test
	public void canOpenNewWizardForPerson(){
		openNewWizardFor("Person");
		cancel();
	}
	
	@Test
	public void canOpenNewWizardForSpecimen(){
		openNewWizardFor("Specimen");
		cancel();
	}
	
	
	@Test
	public void canOpenNewWizardForClassification(){
		openNewWizardFor("Classification");
		cancel();
	}

	private void openNewWizardFor(String entity) {
		bot.menu("General").menu("New").menu(entity).click();
		bot.waitUntil(Conditions.shellIsActive("New Entity"));
	}
}
